
/*************************************************************************
------------------Header FILE------------------------------------------
------This File contains differents functions that allow to communicate---
------with the device-----------------------------------------------------
------They functions is a reunion of differents HPGL instructions that we-
------found in the manufacturer documentation.----------------------------
-------------------------------------by AUDUREAU YOAN---------------------
-------------------------------------& DURAND ANTOINE---------------------
*************************************************************************/


#include "UART.h"
#define MODE_0 0
#define MODE_1 1
#define MODE_2 2
#define MODE_3 3

unsigned char CNC_OUTPUT_ABSOLUTE_COMMANDED_POSITION(int PORT, int *X, int *Y, int *Z );
// Return the ablolute position of the device with 3 variables X,Y,Z

unsigned char CNC_OUTPUT_COMMANDED_POSITION(int PORT, int *X, int *Y, int *Z );
// Return the Commanded position of the device with 3 variables X,Y,Z

unsigned char CNC_CONTOURING_SEGMENT_LENGTH(int PORT,int d);
// Set the maximum X and Y displacement used bu the circular interpolation algorithm to decide if a vector might be part of a curve or not.


unsigned char CNC_CONTOURING_ANGLE(int PORT, int a);
// Sets the maximum value of the inter-vector angle, used by the circular interpolation algorithm to detect curved motions
unsigned char CNC_OUTPUT_SCALE_FACTORS(int PORT, int *X, int *Y, int *Z);
//Give the prescaler value to transform device units in millimeters
unsigned char CNC_OUTPUT_BUFFER_TOTAL_BYTE_COUNT(int PORT);
//Where 1234567890 represent a 10 character ASCII string indicating the total size of the DRAM buffer in bytes
unsigned char Initialisation(int PORT, int d);





