/*************************************************************************
------------------Header FILE---------------------------------------------
------This File contains differents functions that allow to configure------
------the serial port.----------------------------------------------------
------This feature also allows the reading of serial port in order to-----
------detect state changes.-----------------------------------------------
-------------------------------------by AUDUREAU YOAN---------------------
-------------------------------------& DURAND ANTOINE---------------------
*************************************************************************/




#ifndef CNC_H_INCLUDED
#define CNC_H_INCLUDED

      //////////Serial port adress//////////
#define         COM1                 0x3F8
#define         COM2                 0x2F8
#define         COM3                 0x3E8
#define         COM4                 0x2E8


     ///////////Transmission speed////////////
#define         UART_50_BAUDS        0x0900
#define         UART_300_BAUDS       0x0180
#define         UART_600_BAUDS       0x00C0
#define         UART_2400_BAUDS      0x0030
#define         UART_4800_BAUDS      0x0018
#define         UART_9600_BAUDS      0x000C
#define         UART_19200_BAUDS     0x0006
#define         UART_38400_BAUDS     0x0003
#define         UART_57600_BAUDS     0x0002
#define         UART_115200_BAUDS    0x0001

   /////////////Parity////////////
#define         UART_NO_PARITY       0x00
#define         UART_ODD_PARITY      0x08//Impaire
#define         UART_EVEN_PARITY     0x18//Paire
#define         UART_HIGHT_PARITY    0x28
#define         UART_LOW_PARITY      0x38

     ///////////Stop bit////////////
#define         UART_ON_STOP_BIT     0x00
#define         UART_2_STOP_BIT      0x04

      //////////word size///////////
#define         UART_5_BITS          0x00
#define         UART_6_BITS          0x01
#define         UART_7_BITS          0x02
#define         UART_8_BITS          0x03

char Open_Port(int);                                                        //Open the serial Port
void Config_Port (int , int, unsigned char, unsigned char, unsigned char);  //initializes the serial port
char Transmit(int, unsigned char val);                                      //Send a character
char Is_Data_Ready(int PORT);                                               //Check if the trnsmission it possible
char Receive (int PORT);                                                    //Read the serial port character by character
void UART_Send_Buffer (int PORT, char Buffer[], int Nb);                    //Send a string
void UART_Read_Buffer(int PORT,unsigned char Receive[], int Nb);            //Read the serial port and make a string
void Set_RTS (int PORT);                                                    //Set the Bit RTS to 1
void Reset_RTS (int PORT);                                                  //Set the Bit RTS to 0
void Set_DTR (int PORT);                                                    //Set the Bit RTS to 1
void Reset_DTR (int PORT);                                                  //Set the Bit DTS to 0
unsigned char UART_GET_CTS(int PORT);                                       //Read the stat of the CTS bit
char UART_Empty_Data_Holding_Register( int PORT);                           //Read if the device is busy or not
unsigned char UART_GET_RTS(int PORT);                                       //Read the RTS bit

#endif  // CNC_H_INCLUDED
