
/*************************************************************************
------------------Main FILE-----------------------------------------------
------This File contains the main program---------------------------------
------This program can be used in order to command CNC Colinbus with a----
------Joystick------------------------------------------------------------
------It has been developped for a project in IUT of ANGERS --------------
------This program is free software; you can redistribute it and/or modify
------This program is distributed in the hope that it will be useful------
------CNCjoystick.c  Version 2.4------------------------------------------
---------------------------------------------------Copyright (c) 2010-----
----------------------------------by AUDUREAU YOAN------------------------
----------------------------------& DURAND ANTOINE------------------------
*************************************************************************/


#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include <linux/joystick.h>
#include <stdio.h>
#include <stdlib.h>
#include <termios.h>
#include <sys/io.h>
#include <unistd.h>
#include <string.h>
#define         COM1                 0x3F8
#define         COM2                 0x2F8
#define         COM3                 0x3E8
#define         COM4                 0x2E8
#include <fcntl.h>
#include "UART.h"
#include "CNC.h"
#include "CNC_MODE.h"
#include "CNC_MOVE.h"

#include <math.h>
#include <stdio.h>
#include <termios.h>
#include <unistd.h>



#define JOY_DEV "/dev/input/js0"


unsigned char Direction(int *DepX,int *DepY)    // function that allow to know which are direction the joystick
{
    if(*DepX>1000)  *DepX=1;            //if the x axis is oriented to the right put 1
    else if(*DepX<-1000) *DepX=-1;      //if the x axis is oriented to the left put -1
    else *DepX=0;                       //else put 0

    if(*DepY>1000)  *DepY=-1;           //if the y axis is oriented to the right put -1
    else if(*DepY<-1000) *DepY=1;       //if the y axis is oriented to the right put 1
    else *DepY=0;                       //else put 0
}


int main()
{

    //**************main application******************//
    int ErrorFlag,ErrorPos,X,Y,Z,y,z,axex=0,axey=0,PosX=0,PosY=0,PosZ=0,PX,PY;
    unsigned char Current_Mode,ch;

	int joy_fd, *axis=NULL, num_of_axis=0, num_of_buttons=0, x,Pas;
	char *button=NULL, name_of_joystick[80];
	struct js_event js;


    printf("****************************************************************************************\n");
    printf("/////////////////Logiciel Machine à commande numérique Colinbus/////////////////////////\n");
    printf("****************************************************************************************\n");
    printf("* CNCjoystick.c  Version 2.4\n");
    printf("*");
    printf("* Copyright (c) 2010\n");
    printf("*");
    printf("* This program can be used in order to command CNC Colinbus with a Joystick.\n");
    printf("* It has been developped for a project in IUT of ANGERS by Audureau Yoan and Durand Antoine\n");
    printf("* This program is free software; you can redistribute it and/or modify\n");
    printf("* This program is distributed in the hope that it will be useful\n");
    //Initialisation PORT SERIE//
    Initialisation(COM1,120);       // initialize the serial port

    if( ( joy_fd = open( JOY_DEV , O_RDONLY)) == -1 )   // if the joystick doesn't work
	{
		printf( "Couldn't open joystick\n" );
		return -1;
	}

	ioctl( joy_fd, JSIOCGAXES, &num_of_axis );
	ioctl( joy_fd, JSIOCGBUTTONS, &num_of_buttons );
	ioctl( joy_fd, JSIOCGNAME(80), &name_of_joystick );

	axis = (int *) calloc( num_of_axis, sizeof( int ) );
	button = (char *) calloc( num_of_buttons, sizeof( char ) );

	printf("Joystick detected: %s\n\t%d axis\n\t%d buttons\n\n"
		, name_of_joystick
		, num_of_axis
		, num_of_buttons );

    printf("                          Press [ENTER] to continue...");getchar();




	fcntl( joy_fd, F_SETFL, O_NONBLOCK );	/* use non-blocking mode */

    while(!(UART_GET_CTS(COM1)));CNC_OUTPUT_COMMANDED_POSITION(COM1,&X,&Y,&Z);  while(!UART_Empty_Data_Holding_Register(COM1));
	do{
        /* read the joystick state */
		read(joy_fd, &js, sizeof(struct js_event));
        /* see what to do with the event */
		switch (js.type & ~JS_EVENT_INIT)
		{
			case JS_EVENT_AXIS:                     // if an event in analogical axis ...
				axis   [js.number] = js.value;
                printf("x:%d y:%d",X,Y);
                PX=X;PY=Y;
                PosY=axis[1]/3;
                PosX=(axis[0]/2.05);
                Pas=(axis[2]/10);

                if(Pas<0) Pas=-Pas;
                    printf("PAS : %d",Pas);

                Direction(&PosX,&PosY);
                while(!(UART_GET_CTS(COM1)));               // Wait the bit CTS changes to 0
                CNC_PLOT_RELATIVE(COM1,&X,&Y, &Z, PosX*Pas, PosY*Pas);  // move to ...
                while(!UART_Empty_Data_Holding_Register(COM1));     // Wait the buffer is empty

                do
                    {
                        while(!(UART_GET_CTS(COM1)));       // Wait the bit CTS changes to 0
                        CNC_OUTPUT_COMMANDED_POSITION(COM1,&X,&Y,&Z);    //move to ...
                        while(!UART_Empty_Data_Holding_Register(COM1)); // Wait the buffer is empty
                    }
                while((PX!=X)&&(PY!=Y));

                printf("Position envoyée X:%d   Position envoyéeY:%d \n\n",PosX,PosY);
            break;

			case JS_EVENT_BUTTON:                   // if an event in any button
				button [ js.number ] = js.value;
                if(button[3]==1)                //decrease Z axis
                    {
                        PosZ=PosZ+Pas-300;
                        while(!(UART_GET_CTS(COM1)));CNC_ZAXIS_RELATIVE_MOVE(COM1,&X,&Y,&Z,PosZ);while(!UART_Empty_Data_Holding_Register(COM1));
                    }

                if(button[4]==1)            //increase Z axis
                    {
                        PosZ=PosZ-Pas-300;
                        while(!(UART_GET_CTS(COM1)));CNC_ZAXIS_RELATIVE_MOVE(COM1,&X,&Y,&Z,PosZ);while(!UART_Empty_Data_Holding_Register(COM1));
                    }
                if(button[7]==1)        //move to 0,0,0 and initializes
                    {
                        while(!(UART_GET_CTS(COM1)));CNC_MOVE_XY(COM1,&X,&Y,&Z,60,0,0);  while(!UART_Empty_Data_Holding_Register(COM1));
                        while(!(UART_GET_CTS(COM1)));CNC_Init_XYZ(COM1);while(!UART_Empty_Data_Holding_Register(COM1));
                    }

                /*Move precisely*/

                if(button[5]==1)        //increase X
                    {
                        while(!(UART_GET_CTS(COM1)));CNC_PLOT_RELATIVE(COM1,&X,&Y, &Z, Pas, 0); while(!UART_Empty_Data_Holding_Register(COM1));
                    }
                if(button[6]==1)        //decrease X
                    {
                        while(!(UART_GET_CTS(COM1)));CNC_PLOT_RELATIVE(COM1,&X,&Y, &Z, -Pas, 0); while(!UART_Empty_Data_Holding_Register(COM1));
                    }
                if(button[10]==1)       //increase Y
                    {
                        while(!(UART_GET_CTS(COM1)));CNC_PLOT_RELATIVE(COM1,&X,&Y, &Z, 0, Pas); while(!UART_Empty_Data_Holding_Register(COM1));
                    }
                if(button[9]==1)       //decrease Y
                    {
                        while(!(UART_GET_CTS(COM1)));CNC_PLOT_RELATIVE(COM1,&X,&Y, &Z, 0, -Pas); while(!UART_Empty_Data_Holding_Register(COM1));
                    }

            break;
        default : break;
		}

    /* print the results */
    printf( "X: %6d  Y: %6d  ", axis[1], axis[0] );
    if( num_of_axis > 2 )
			printf("Z: %6d  ", axis[2] );
    if( num_of_axis > 3 )
			printf("R: %6d  ", axis[3] );
    for( x=0 ; x<num_of_buttons ; ++x )
			printf("B%d: %d  ", x, button[x] );
    printf("  \r");
    fflush(stdout);
    //system ("clear");
	}while(1);

	close( joy_fd );

//****************Test Deplacement relatif********************//

/*
    unsigned char SX,SY;
    int XX=0,YY=0,ZZ=0;

    CNC_MOVE_XY(COM1,&X,&Y,&Z,60,1000,1000);
    do
        {
            printf("Déplacement X:");scanf("%d",&XX);                       //Saisie des coordonnées de X
            printf("Déplacement Y:");scanf("%d",&YY);                       //Saisie des coordonnées de Y
            printf("Déplacement Z:");scanf("%d",&ZZ);                       //Saisie des coordonnées de Z
            if(CNC_PLOT_RELATIVE(COM1,&X,&Y,&Z,XX,YY)!=0) return 0;         //Interrompt le programme si erreur dans PLOT RELATIVE
            if(CNC_ZAXIS_RELATIVE_MOVE(COM1,&X,&Y,&Z, ZZ)!=0)return 0;      //Interrompt le programme si erreur dans Z RELATIVE
        }while(1);
*/

//*************************Test Déplacement absolu***********************//
/*
    int ,A=0,B=0,V,C=0,zd;
    printf("V:");scanf("%d",&V);getchar();                              //Vitesse axe XY
    printf("zd:");scanf("%d",&zd);getchar();                            //Vitesse axe Z
    do
        {
            printf("X:");scanf("%d",&A);getchar();                      //Coordonnée X
            printf("Y:");scanf("%d",&B);getchar();                      //Coordonnée Y
            printf("Z:");scanf("%d",&C);getchar();                      //Coordonnée Z

            printf(" Déplacement X:%d , Y:%d, Z:%d \n\n",A,B,C);

            ErrorPos=CNC_MOVE_XY(COM1,&X,&Y,&Z,V,A,B);                  //Deplacement XY
            if(ErrorPos) printf(" ERREUR DE COORDONNEE ");

            if(CNC_MOVE_Z(COM1,&X,&Y,&Z,zd,C))printf("ERREUR SUR Z");   //Deplacement Z

        }while(1);

*/


    printf("                          Press [ENTER] ...");
    getchar();
    return 0;


}
